diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index a4d28415d17..6b88bec67ef 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -87,7 +87,6 @@ struct wine_input_absinfo {
 /* implemented in effect_linuxinput.c */
 HRESULT linuxinput_create_effect(int* fd, REFGUID rguid, struct list *parent_list_entry, LPDIRECTINPUTEFFECT* peff);
 HRESULT linuxinput_get_info_A(int fd, REFGUID rguid, LPDIEFFECTINFOA info);
-HRESULT linuxinput_get_info_W(int fd, REFGUID rguid, LPDIEFFECTINFOW info);
 
 typedef struct JoystickImpl JoystickImpl;
 static const IDirectInputDevice8WVtbl JoystickWvt;
@@ -165,6 +164,7 @@ static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD
 static HRESULT CDECL unix_joystick_ff_get_state(struct unix_joystick *ptr, DWORD *state);
 static HRESULT CDECL unix_joystick_ff_send_cmd(struct unix_joystick *ptr, DWORD flags);
 
+static HRESULT CDECL unix_joystick_get_effect_info(struct unix_joystick *ptr, REFGUID guid, LPDIEFFECTINFOA diei);
 static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect,
         struct list *entry, IDirectInputEffect **out);
 
@@ -176,6 +176,7 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     unix_joystick_ff_set_gain,
     unix_joystick_ff_get_state,
     unix_joystick_ff_send_cmd,
+    unix_joystick_get_effect_info,
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
     unix_joystick_create_effect,
 #else
@@ -995,16 +996,14 @@ static HRESULT WINAPI JoystickWImpl_EnumEffects(LPDIRECTINPUTDEVICE8W iface,
 /*******************************************************************************
  *      GetEffectInfo - Get information about a particular effect 
  */
-static HRESULT WINAPI JoystickWImpl_GetEffectInfo(LPDIRECTINPUTDEVICE8W iface,
-                                                  LPDIEFFECTINFOW pdei,
-                                                  REFGUID guid)
+static HRESULT CDECL unix_joystick_get_effect_info(struct unix_joystick *ptr, REFGUID guid, DIEFFECTINFOA *diei)
 {
-    JoystickImpl* This = impl_from_IDirectInputDevice8W(iface);
+    JoystickImpl* This = impl_from_unix_joystick(ptr);
 
-    TRACE("(this=%p,%p,%s)\n", This, pdei, _dump_dinput_GUID(guid));
+    TRACE("(this=%p,%p,%s)\n", This, diei, _dump_dinput_GUID(guid));
 
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
-    return linuxinput_get_info_W(This->joyfd, guid, pdei);
+    return linuxinput_get_info_A(This->joyfd, guid, diei);
 #else
     return DI_OK;
 #endif
@@ -1085,7 +1084,7 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     IDirectInputDevice2WImpl_Initialize,
     JoystickWGenericImpl_CreateEffect,
     JoystickWImpl_EnumEffects,
-    JoystickWImpl_GetEffectInfo,
+    JoystickWGenericImpl_GetEffectInfo,
     JoystickWGenericImpl_GetForceFeedbackState,
     JoystickWGenericImpl_SendForceFeedbackCommand,
     JoystickWGenericImpl_EnumCreatedEffectObjects,
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index 56f9abb76a8..f44ba2c1357 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -957,6 +957,7 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     unix_joystick_ff_set_gain,
     NULL,
     unix_joystick_ff_send_cmd,
+    NULL,
     unix_joystick_create_effect,
     unix_joystick_poll,
 };
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index b8239438a2b..f76301a5d17 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -45,6 +45,7 @@ struct unix_joystick_vtbl
     HRESULT (CDECL *ff_get_state)(struct unix_joystick *ptr, DWORD *state);
     HRESULT (CDECL *ff_send_cmd)(struct unix_joystick *ptr, DWORD flags);
 
+    HRESULT (CDECL *get_effect_info)(struct unix_joystick *ptr, REFGUID guid, DIEFFECTINFOA *diei);
     HRESULT (CDECL *create_effect)(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect, struct list *entry, IDirectInputEffect **out);
 
     void (CDECL *poll)(struct unix_joystick *ptr);
@@ -91,6 +92,8 @@ HRESULT WINAPI JoystickWGenericImpl_Acquire(LPDIRECTINPUTDEVICE8W iface) DECLSPE
 
 HRESULT WINAPI JoystickWGenericImpl_Unacquire(LPDIRECTINPUTDEVICE8W iface) DECLSPEC_HIDDEN;
 
+HRESULT WINAPI JoystickWGenericImpl_GetEffectInfo(LPDIRECTINPUTDEVICE8W iface, LPDIEFFECTINFOW pdei, REFGUID rguid) DECLSPEC_HIDDEN;
+
 HRESULT WINAPI JoystickWGenericImpl_CreateEffect(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIEFFECT lpeff,
         LPDIRECTINPUTEFFECT *ppdef, LPUNKNOWN pUnkOuter) DECLSPEC_HIDDEN;
 
-- 
2.28.0

>From 7235aa8b461b0d177b0291371adf8676d953dd7a Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 23:34:02 +0200
Subject: [PATCH 21/39] dinput: Use the unix vtable for EnumEffects.

---
 dlls/dinput/joystick.c            |  29 +++++++
 dlls/dinput/joystick_linux.c      |   1 +
 dlls/dinput/joystick_linuxinput.c | 121 ++++++++++++++----------------
 dlls/dinput/joystick_osx.c        |   1 +
 dlls/dinput/joystick_private.h    |   4 +
 5 files changed, 90 insertions(+), 66 deletions(-)

diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 6d36bdbbbe8..d2fffb4fe5e 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -739,6 +739,35 @@ HRESULT WINAPI JoystickWGenericImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REF
     return DI_OK;
 }
 
+HRESULT WINAPI JoystickWGenericImpl_EnumEffects(LPDIRECTINPUTDEVICE8W iface, LPDIENUMEFFECTSCALLBACKW lpCallback,
+        LPVOID pvRef, DWORD dwEffType)
+{
+    JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
+    DIEFFECTINFOW dei;
+    const GUID **guids;
+    HRESULT hr;
+    DWORD i, count;
+    BOOL acquired = This->base.acquired;
+
+    TRACE("(this=%p,%p,%d)\n", This, pvRef, dwEffType);
+    if (!This->unix_funcs->list_effects) return DI_OK;
+
+    if (FAILED(hr = This->unix_funcs->list_effects(This->unix_ptr, DIEFT_GETTYPE(dwEffType), NULL, 0, &count))) return hr;
+    if (!(guids = HeapAlloc(GetProcessHeap(), 0, sizeof(*guids) * count))) return DIERR_OUTOFMEMORY;
+    if (FAILED(hr = This->unix_funcs->list_effects(This->unix_ptr, DIEFT_GETTYPE(dwEffType), guids, count, &count))) goto done;
+
+    for (i = 0; i < count; ++i)
+    {
+        if (FAILED(hr = IDirectInputDevice8_GetEffectInfo(iface, &dei, guids[i]))) goto done;
+        (*lpCallback)(&dei, pvRef);
+    }
+
+done:
+    HeapFree(GetProcessHeap(), 0, guids);
+    if (!acquired) IDirectInputDevice8_Unacquire(iface);
+    return hr;
+}
+
 static void dieffectinfo_atow(const DIEFFECTINFOA *dieia, DIEFFECTINFOW *dieiw)
 {
     dieiw->guid = dieia->guid;
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index d8611d72774..9055565a902 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -148,6 +148,7 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     NULL,
     NULL,
     NULL,
+    NULL,
     unix_joystick_poll,
 };
 
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 6b88bec67ef..ec5bd7eb157 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -164,6 +164,7 @@ static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD
 static HRESULT CDECL unix_joystick_ff_get_state(struct unix_joystick *ptr, DWORD *state);
 static HRESULT CDECL unix_joystick_ff_send_cmd(struct unix_joystick *ptr, DWORD flags);
 
+static HRESULT CDECL unix_joystick_list_effects(struct unix_joystick *ptr, DWORD type, const GUID **guids, DWORD size, DWORD *count);
 static HRESULT CDECL unix_joystick_get_effect_info(struct unix_joystick *ptr, REFGUID guid, LPDIEFFECTINFOA diei);
 static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect,
         struct list *entry, IDirectInputEffect **out);
@@ -176,6 +177,7 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     unix_joystick_ff_set_gain,
     unix_joystick_ff_get_state,
     unix_joystick_ff_send_cmd,
+    unix_joystick_list_effects,
     unix_joystick_get_effect_info,
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
     unix_joystick_create_effect,
@@ -913,83 +915,70 @@ static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFG
 /*******************************************************************************
  *	EnumEffects - Enumerate available FF effects
  */
-static HRESULT WINAPI JoystickWImpl_EnumEffects(LPDIRECTINPUTDEVICE8W iface,
-                                                LPDIENUMEFFECTSCALLBACKW lpCallback,
-                                                LPVOID pvRef,
-                                                DWORD dwEffType)
+static HRESULT CDECL unix_joystick_list_effects(struct unix_joystick *ptr, DWORD type, const GUID **guids, DWORD size, DWORD *count)
 {
-#ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
-    /* seems silly to duplicate all this code but all the structures and functions
-     * are actually different (A/W) */
-    DIEFFECTINFOW dei; /* feif */
-    DWORD type = DIEFT_GETTYPE(dwEffType);
-    JoystickImpl* This = impl_from_IDirectInputDevice8W(iface);
-    int xfd = This->joyfd;
-
-    TRACE("(this=%p,%p,%d) type=%d fd=%d\n", This, pvRef, dwEffType, type, xfd);
-
-    dei.dwSize = sizeof(DIEFFECTINFOW);          
+    JoystickImpl* This = impl_from_unix_joystick(ptr);
+    DWORD i = 0;
 
-    if ((type == DIEFT_ALL || type == DIEFT_CONSTANTFORCE)
-	&& test_bit(This->joydev->ffbits, FF_CONSTANT)) {
-	IDirectInputDevice8_GetEffectInfo(iface, &dei, &GUID_ConstantForce);
-	(*lpCallback)(&dei, pvRef);
+#ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
+    if ((type == DIEFT_ALL || type == DIEFT_CONSTANTFORCE) && test_bit(This->joydev->ffbits, FF_CONSTANT))
+    {
+        if (guids && i < size) guids[i++] = &GUID_ConstantForce;
+        else i++;
     }
 
-    if ((type == DIEFT_ALL || type == DIEFT_PERIODIC)
-	&& test_bit(This->joydev->ffbits, FF_PERIODIC)) {
-	if (test_bit(This->joydev->ffbits, FF_SQUARE)) {
-	    IDirectInputDevice8_GetEffectInfo(iface, &dei, &GUID_Square);
-	    (*lpCallback)(&dei, pvRef);
-	}
-	if (test_bit(This->joydev->ffbits, FF_SINE)) {
-            IDirectInputDevice8_GetEffectInfo(iface, &dei, &GUID_Sine);
-	    (*lpCallback)(&dei, pvRef);
-	}
-	if (test_bit(This->joydev->ffbits, FF_TRIANGLE)) {
-	    IDirectInputDevice8_GetEffectInfo(iface, &dei, &GUID_Triangle);
-	    (*lpCallback)(&dei, pvRef);
-	}
-	if (test_bit(This->joydev->ffbits, FF_SAW_UP)) {
-	    IDirectInputDevice8_GetEffectInfo(iface, &dei, &GUID_SawtoothUp);
-	    (*lpCallback)(&dei, pvRef);
-	}
-	if (test_bit(This->joydev->ffbits, FF_SAW_DOWN)) {
-	    IDirectInputDevice8_GetEffectInfo(iface, &dei, &GUID_SawtoothDown);
-	    (*lpCallback)(&dei, pvRef);
-	}
-    } 
+    if ((type == DIEFT_ALL || type == DIEFT_PERIODIC) && test_bit(This->joydev->ffbits, FF_PERIODIC))
+    {
+        if (test_bit(This->joydev->ffbits, FF_SQUARE))
+        {
+            if (guids && i < size) guids[i++] = &GUID_Square;
+            else i++;
+        }
+        if (test_bit(This->joydev->ffbits, FF_SINE)) {
+            if (guids && i < size) guids[i++] = &GUID_Sine;
+            else i++;
+        }
+        if (test_bit(This->joydev->ffbits, FF_TRIANGLE)) {
+            if (guids && i < size) guids[i++] = &GUID_Triangle;
+            else i++;
+        }
+        if (test_bit(This->joydev->ffbits, FF_SAW_UP)) {
+            if (guids && i < size) guids[i++] = &GUID_SawtoothUp;
+            else i++;
+        }
+        if (test_bit(This->joydev->ffbits, FF_SAW_DOWN)) {
+            if (guids && i < size) guids[i++] = &GUID_SawtoothDown;
+            else i++;
+        }
+    }
 
-    if ((type == DIEFT_ALL || type == DIEFT_RAMPFORCE)
-	&& test_bit(This->joydev->ffbits, FF_RAMP)) {
-        IDirectInputDevice8_GetEffectInfo(iface, &dei, &GUID_RampForce);
-        (*lpCallback)(&dei, pvRef);
+    if ((type == DIEFT_ALL || type == DIEFT_RAMPFORCE) && test_bit(This->joydev->ffbits, FF_RAMP))
+    {
+        if (guids && i < size) guids[i++] = &GUID_RampForce;
+        else i++;
     }
 
     if (type == DIEFT_ALL || type == DIEFT_CONDITION) {
 	if (test_bit(This->joydev->ffbits, FF_SPRING)) {
-	    IDirectInputDevice8_GetEffectInfo(iface, &dei, &GUID_Spring);
-	    (*lpCallback)(&dei, pvRef);
-	}
-	if (test_bit(This->joydev->ffbits, FF_DAMPER)) {
-	    IDirectInputDevice8_GetEffectInfo(iface, &dei, &GUID_Damper);
-	    (*lpCallback)(&dei, pvRef);
-	}
-	if (test_bit(This->joydev->ffbits, FF_INERTIA)) {
-	    IDirectInputDevice8_GetEffectInfo(iface, &dei, &GUID_Inertia);
-	    (*lpCallback)(&dei, pvRef);
-	}
-	if (test_bit(This->joydev->ffbits, FF_FRICTION)) {
-	    IDirectInputDevice8_GetEffectInfo(iface, &dei, &GUID_Friction);
-	    (*lpCallback)(&dei, pvRef);
-	}
+            if (guids && i < size) guids[i++] = &GUID_Spring;
+            else i++;
+        }
+        if (test_bit(This->joydev->ffbits, FF_DAMPER)) {
+            if (guids && i < size) guids[i++] = &GUID_Damper;
+            else i++;
+        }
+        if (test_bit(This->joydev->ffbits, FF_INERTIA)) {
+            if (guids && i < size) guids[i++] = &GUID_Inertia;
+            else i++;
+        }
+        if (test_bit(This->joydev->ffbits, FF_FRICTION)) {
+            if (guids && i < size) guids[i++] = &GUID_Friction;
+            else i++;
+        }
     }
-
-    /* return to unacquired state if that's where it was */
-    if (xfd == -1)
-	IDirectInputDevice8_Unacquire(iface);
 #endif
 
+    if (count) *count = i;
     return DI_OK;
 }
 
@@ -1083,7 +1072,7 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     IDirectInputDevice2WImpl_RunControlPanel,
     IDirectInputDevice2WImpl_Initialize,
     JoystickWGenericImpl_CreateEffect,
-    JoystickWImpl_EnumEffects,
+    JoystickWGenericImpl_EnumEffects,
     JoystickWGenericImpl_GetEffectInfo,
     JoystickWGenericImpl_GetForceFeedbackState,
     JoystickWGenericImpl_SendForceFeedbackCommand,
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index f44ba2c1357..19c2e2dddf4 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -958,6 +958,7 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     NULL,
     unix_joystick_ff_send_cmd,
     NULL,
+    NULL,
     unix_joystick_create_effect,
     unix_joystick_poll,
 };
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index f76301a5d17..e479ea6b480 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -45,6 +45,7 @@ struct unix_joystick_vtbl
     HRESULT (CDECL *ff_get_state)(struct unix_joystick *ptr, DWORD *state);
     HRESULT (CDECL *ff_send_cmd)(struct unix_joystick *ptr, DWORD flags);
 
+    HRESULT (CDECL *list_effects)(struct unix_joystick *ptr, DWORD type, const GUID **guids, DWORD size, DWORD *count);
     HRESULT (CDECL *get_effect_info)(struct unix_joystick *ptr, REFGUID guid, DIEFFECTINFOA *diei);
     HRESULT (CDECL *create_effect)(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect, struct list *entry, IDirectInputEffect **out);
 
@@ -94,6 +95,9 @@ HRESULT WINAPI JoystickWGenericImpl_Unacquire(LPDIRECTINPUTDEVICE8W iface) DECLS
 
 HRESULT WINAPI JoystickWGenericImpl_GetEffectInfo(LPDIRECTINPUTDEVICE8W iface, LPDIEFFECTINFOW pdei, REFGUID rguid) DECLSPEC_HIDDEN;
 
+HRESULT WINAPI JoystickWGenericImpl_EnumEffects(LPDIRECTINPUTDEVICE8W iface, LPDIENUMEFFECTSCALLBACKW lpCallback,
+        LPVOID pvRef, DWORD dwEffType) DECLSPEC_HIDDEN;
+
 HRESULT WINAPI JoystickWGenericImpl_CreateEffect(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIEFFECT lpeff,
         LPDIRECTINPUTEFFECT *ppdef, LPUNKNOWN pUnkOuter) DECLSPEC_HIDDEN;
 
-- 
2.28.0

>From d721587951564d31a4f7e80d37070432a8214684 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 23:49:55 +0200
Subject: [PATCH 22/39] dinput: Introduce create_unix_joystick funtion pointer.

---
 dlls/dinput/device.c              |   2 +
 dlls/dinput/dinput_private.h      |   2 +
 dlls/dinput/joystick.c            |  21 ++++++
 dlls/dinput/joystick_linux.c      | 116 ++++++++++++------------------
 dlls/dinput/joystick_linuxinput.c |  96 ++++++++++++-------------
 dlls/dinput/joystick_osx.c        |  88 +++++++++--------------
 dlls/dinput/joystick_private.h    |   2 +
 dlls/dinput/keyboard.c            |   3 +-
 dlls/dinput/mouse.c               |   3 +-
 9 files changed, 157 insertions(+), 176 deletions(-)

diff --git a/dlls/dinput/device.c b/dlls/dinput/device.c
index a2c1b638cfc..af05fdf14f0 100644
--- a/dlls/dinput/device.c
+++ b/dlls/dinput/device.c
@@ -39,6 +39,7 @@
 #include "dinput.h"
 #include "device_private.h"
 #include "dinput_private.h"
+#include "joystick_private.h"
 
 #define WM_WINE_NOTIFY_ACTIVITY WM_USER
 
@@ -1667,6 +1668,7 @@ HRESULT dinput_create_device(const struct dinput_device *device, IDirectInputImp
     IDirectInputDeviceImpl *This;
     HRESULT hr;
 
+    if (device->create_unix_joystick) return dinput_create_unix_joystick(device, dinput, guid, iid, out);
     if (!device->create_device) return E_FAIL;
     if (FAILED(hr = device->create_device(dinput, guid, &This))) return hr;
     if (!FAILED(hr = IDirectInputDevice8_QueryInterface(IDirectInputDevice8W_from_impl(This), iid, out)))
diff --git a/dlls/dinput/dinput_private.h b/dlls/dinput/dinput_private.h
index 472f21adb1b..9f3214eb260 100644
--- a/dlls/dinput/dinput_private.h
+++ b/dlls/dinput/dinput_private.h
@@ -53,6 +53,7 @@ extern const IDirectInput7AVtbl direct_input_7_a_vtbl DECLSPEC_HIDDEN;
 extern const IDirectInput8AVtbl direct_input_8_a_vtbl DECLSPEC_HIDDEN;
 
 typedef struct IDirectInputDeviceImpl IDirectInputDeviceImpl;
+typedef struct JoystickGenericImpl JoystickGenericImpl;
 
 /* Function called by all devices that Wine supports */
 struct dinput_device {
@@ -60,6 +61,7 @@ struct dinput_device {
     HRESULT (*enum_deviceA)(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id);
     HRESULT (*enum_deviceW)(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEW lpddi, DWORD version, int id);
     HRESULT (*create_device)(IDirectInputImpl *dinput, REFGUID rguid, IDirectInputDeviceImpl **out);
+    HRESULT (*create_unix_joystick)(IDirectInputImpl *dinput, REFGUID rguid, JoystickGenericImpl **out);
 };
 
 extern HRESULT dinput_create_device(const struct dinput_device *device, IDirectInputImpl *dinput, REFGUID guid,
diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index d2fffb4fe5e..94525875ca5 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -65,6 +65,10 @@ static inline JoystickGenericImpl *impl_from_IDirectInputDevice8W(IDirectInputDe
 {
     return CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface), JoystickGenericImpl, base);
 }
+static inline IDirectInputDevice8W *IDirectInputDevice8W_from_impl(JoystickGenericImpl *This)
+{
+    return &This->base.IDirectInputDevice8W_iface;
+}
 
 DWORD typeFromGUID(REFGUID guid)
 {
@@ -1169,3 +1173,20 @@ HRESULT setup_dinput_options(JoystickGenericImpl *This, const int *default_axis_
 
     return DI_OK;
 }
+
+HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectInputImpl *dinput, REFGUID guid, REFIID iid, void **out)
+{
+    JoystickGenericImpl *This;
+    HRESULT hr;
+
+    if (FAILED(hr = device->create_unix_joystick(dinput, guid, &This))) return hr;
+    if (FAILED(hr = IDirectInputDevice8_QueryInterface(IDirectInputDevice8W_from_impl(This), iid, out))) goto done;
+
+    TRACE("created unix joystick %p\n", This);
+    if (TRACE_ON(dinput)) _dump_DIDATAFORMAT(This->base.data_format.wine_df);
+
+done:
+    /* IDirectInputDevice8_QueryInterface increased refcount */
+    IDirectInputDevice8_Release(IDirectInputDevice8W_from_impl(This));
+    return hr;
+}
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 9055565a902..ae75a3dbf20 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -447,23 +447,47 @@ static HRESULT joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINS
     return S_FALSE;
 }
 
-static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
-                            JoystickImpl **pdev, unsigned short index)
+/******************************************************************************
+  *     get_joystick_index : Get the joystick index from a given GUID
+  */
+static unsigned short get_joystick_index(REFGUID guid)
+{
+    GUID wine_joystick = DInput_Wine_Joystick_GUID;
+    GUID dev_guid = *guid;
+
+    wine_joystick.Data3 = 0;
+    dev_guid.Data3 = 0;
+
+    /* for the standard joystick GUID use index 0 */
+    if (IsEqualGUID(&GUID_Joystick, guid)) return 0;
+
+    /* for the wine joystick GUIDs use the index stored in Data3 */
+    if (IsEqualGUID(&wine_joystick, &dev_guid)) return guid->Data3;
+
+    return MAX_JOYSTICKS;
+}
+
+static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID guid, JoystickGenericImpl **out)
 {
-    struct JoyDev *joydev = &joystick_devices[index];
+    struct JoyDev *joydev;
     DIDEVICEINSTANCEW didi = {sizeof(didi)};
-    DWORD i;
-    JoystickImpl* newDevice;
-    HRESULT hr;
     LPDIDATAFORMAT df = NULL;
-    int idx = 0;
+    JoystickImpl *newDevice;
+    HRESULT hr;
+    DWORD i, index, idx = 0;
+
+    TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
 
-    TRACE("%s %p %p %hu\n", debugstr_guid(rguid), dinput, pdev, index);
+    find_joystick_devices();
+
+    *out = NULL;
+    if ((index = get_joystick_index(guid)) >= MAX_JOYSTICKS || !joystick_devices_count || index >= joystick_devices_count)
+        return DIERR_DEVICENOTREG;
+    joydev = &joystick_devices[index];
 
     fill_joystick_dideviceinstanceW(&didi, dinput->dwVersion, index);
 
-    *pdev = NULL;
-    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, rguid, joydev->vendor_id,
+    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, guid, joydev->vendor_id,
                        joydev->product_id, index, &didi, dinput, (void **)&newDevice)))
         return hr;
     newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->generic.base.crit");
@@ -472,7 +496,7 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
 
     newDevice->joydev = joydev;
     newDevice->joyfd = -1;
-    newDevice->generic.name        = newDevice->joydev->name;
+    newDevice->generic.name = newDevice->joydev->name;
     newDevice->generic.device_axis_count = newDevice->joydev->axis_count;
     newDevice->generic.devcaps.dwButtons = newDevice->joydev->button_count;
 
@@ -486,16 +510,15 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
     newDevice->generic.deadzone = 0;
 
     /* do any user specified configuration */
-    hr = setup_dinput_options(&newDevice->generic, newDevice->joydev->dev_axes_map);
-    if (hr != DI_OK)
-        goto FAILED1;
+    if (FAILED(hr = setup_dinput_options(&newDevice->generic, newDevice->joydev->dev_axes_map))) goto failed;
 
     /* Create copy of default data format */
-    if (!(df = HeapAlloc(GetProcessHeap(), 0, c_dfDIJoystick2.dwSize))) goto FAILED;
+    hr = DIERR_OUTOFMEMORY;
+    if (!(df = HeapAlloc(GetProcessHeap(), 0, c_dfDIJoystick2.dwSize))) goto failed;
     memcpy(df, &c_dfDIJoystick2, c_dfDIJoystick2.dwSize);
 
     df->dwNumObjs = newDevice->generic.devcaps.dwAxes + newDevice->generic.devcaps.dwPOVs + newDevice->generic.devcaps.dwButtons;
-    if (!(df->rgodf = HeapAlloc(GetProcessHeap(), 0, df->dwNumObjs * df->dwObjSize))) goto FAILED;
+    if (!(df->rgodf = HeapAlloc(GetProcessHeap(), 0, df->dwNumObjs * df->dwObjSize))) goto failed;
 
     for (i = 0; i < newDevice->generic.device_axis_count; i++)
     {
@@ -541,76 +564,31 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
     newDevice->generic.devcaps.dwFFDriverVersion = 0;
 
     if (TRACE_ON(dinput)) {
-       for (i = 0; i < (newDevice->generic.device_axis_count); i++)
-           TRACE("axis_map[%d] = %d\n", i, newDevice->generic.axis_map[i]);
+        for (i = 0; i < (newDevice->generic.device_axis_count); i++)
+            TRACE("axis_map[%d] = %d\n", i, newDevice->generic.axis_map[i]);
         _dump_DIDEVCAPS(&newDevice->generic.devcaps);
     }
 
-    *pdev = newDevice;
-
+    *out = &newDevice->generic;
     return DI_OK;
 
-FAILED:
-    hr = DIERR_OUTOFMEMORY;
-FAILED1:
+failed:
     if (df) HeapFree(GetProcessHeap(), 0, df->rgodf);
     HeapFree(GetProcessHeap(), 0, df);
     release_DataFormat(&newDevice->generic.base.data_format);
-    HeapFree(GetProcessHeap(),0,newDevice->generic.axis_map);
-    HeapFree(GetProcessHeap(),0,newDevice);
-    *pdev = 0;
-
+    HeapFree(GetProcessHeap(), 0, newDevice->generic.axis_map);
+    HeapFree(GetProcessHeap(), 0, newDevice);
     return hr;
 }
 
-/******************************************************************************
-  *     get_joystick_index : Get the joystick index from a given GUID
-  */
-static unsigned short get_joystick_index(REFGUID guid)
-{
-    GUID wine_joystick = DInput_Wine_Joystick_GUID;
-    GUID dev_guid = *guid;
-
-    wine_joystick.Data3 = 0;
-    dev_guid.Data3 = 0;
-
-    /* for the standard joystick GUID use index 0 */
-    if(IsEqualGUID(&GUID_Joystick,guid)) return 0;
-
-    /* for the wine joystick GUIDs use the index stored in Data3 */
-    if(IsEqualGUID(&wine_joystick, &dev_guid)) return guid->Data3;
-
-    return MAX_JOYSTICKS;
-}
-
-static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDirectInputDeviceImpl **out)
-{
-    unsigned short index;
-
-    TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
-    find_joystick_devices();
-    *out = NULL;
-
-    if ((index = get_joystick_index(guid)) < MAX_JOYSTICKS &&
-        joystick_devices_count && index < joystick_devices_count)
-    {
-        JoystickImpl *This;
-        HRESULT hr = alloc_device(guid, dinput, &This, index);
-        if (!This) return hr;
-        *out = &This->generic.base;
-        return hr;
-    }
-
-    return DIERR_DEVICENOTREG;
-}
-
 #undef MAX_JOYSTICKS
 
 const struct dinput_device joystick_linux_device = {
   "Wine Linux joystick driver",
   joydev_enum_deviceA,
   NULL,
-  joydev_create_device
+  NULL,
+  joydev_create_unix_joystick
 };
 
 /******************************************************************************
